// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/Pie/2dsector.h#6 $
// $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $ 
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////


#ifndef __2DSECTOR_H__
#define __2DSECTOR_H__

#ifdef _PIE_
#define EXPIMP __declspec(dllexport)
#else
#define EXPIMP
#endif

#pragma warning( disable : 4275 )

#define AsdkPieServiceName ACRX_T("AsdkPieService")

class EXPIMP Asdk2dSector : public AcDbEntity {
protected:
    AcGePoint3d m_center ;
    double m_radius ;
    double m_start, m_stop ;
    AcGeVector3d m_normal ;

public:
    Asdk2dSector () ;
    virtual ~Asdk2dSector () ;

    virtual AcGePoint3d center () const ;
    virtual void setCenter (const AcGePoint3d &pt) ;
    virtual double radius () const ;
    virtual void setRadius (const double rad) ;
    virtual double start () const ;
    virtual void setStart (const double start) ;
    virtual double stop () const ;
    virtual void setStop (const double stop) ;
    virtual AcGeVector3d normal () const ;
    virtual void setNormal (const AcGeVector3d &vt) ;

    Acad::ErrorStatus getVertices (AcGePoint3dArray &vertexArray, bool bFlag =false) const ;
    // error C3248: 'AcGiDrawable::getGripPoints': function declared as 'sealed' cannot be 
    // overridden by 'Asdk2dSector::getGripPoints'
    //virtual Acad::ErrorStatus getGripPoints (
    //    AcGePoint3dArray &gripPoints,
    //    AcDbIntArray &osnapModes,
    //    AcDbIntArray &geomIds
    //) const ;
    // error C3248: 'AcGiDrawable::moveGripPointsAt': function declared as 'sealed' cannot be 
    // overridden by 'Asdk2dSector::moveGripPointsAt'
    //virtual Acad::ErrorStatus moveGripPointsAt (
    //    const AcDbIntArray &indices,
    //    const AcGeVector3d &offset
    //) ;
    // error C3248: 'AcGiDrawable::getOsnapPoints': function declared as 'sealed' cannot be 
    // overridden by 'Asdk2dSector::getOsnapPoints'
    //virtual Acad::ErrorStatus getOsnapPoints (
    //    AcDb::OsnapMode osnapMode,
    //    int gsSelectionMark,
    //    const AcGePoint3d &pickPoint,
    //    const AcGePoint3d &lastPoint,
    //    const AcGeMatrix3d &viewXform,
    //    AcGePoint3dArray &snapPoints,
    //    AcDbIntArray &geomIds
    //) const ;
//------ Default is xxxGripPoints ()
//	virtual Acad::ErrorStatus getStretchPoints (AcGePoint3dArray &stretchPoints) const ;
//------ Default is transformBy ()
//	virtual Acad::ErrorStatus moveStretchPoints (const AcDbIntArray &indices, const AcGeVector3d &offset) ;

    virtual Acad::ErrorStatus dxfOutFields (AcDbDxfFiler *pFiler) const ;
    virtual Acad::ErrorStatus dxfInFields (AcDbDxfFiler *pFiler) ;
    virtual Acad::ErrorStatus dwgOutFields (AcDbDwgFiler *pFiler) const ;
    virtual Acad::ErrorStatus dwgInFields (AcDbDwgFiler *pFiler) ;

    // error C3248: 'AcGiDrawable::transformBy': function declared as 'sealed' cannot be 
    // overridden by 'Asdk2dSector::transformBy'
    //virtual Acad::ErrorStatus transformBy (const AcGeMatrix3d &xform) ;

    // error C3248: 'AcGiDrawable::worldDraw': function declared as 'sealed' cannot be 
    // overridden by 'Asdk2dSector::worldDraw'
    //virtual Adesk::Boolean worldDraw (AcGiWorldDraw *) ;
    virtual void saveAs (AcGiWorldDraw* mode, AcDb::SaveType st) ;

    //virtual void viewportDraw (AcGiViewportDraw *mode) ;

    ACRX_DECLARE_MEMBERS (Asdk2dSector) ;

#ifdef MEM_DEBUG
#undef new
#undef delete
#endif
    void *operator new[](size_t nSize) { return 0;}
    void operator delete[](void *p) {};
    void *operator new[](size_t nSize, const ACHAR *file, int line) { return 0;}
#ifdef MEM_DEBUG
#define new DEBUG_NEW
#define delete DEBUG_DELETE
#endif
} ;

#endif //----- __2DSECTOR_H__
