// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/Pie/tools.cpp#2 $ $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////


#include "acgi.h"
#include "geassign.h"
#include "gescl3d.h"

//-----------------------------------------------------------------------------
#define PI 3.14159265358979323846

//-----------------------------------------------------------------------------
void ucs2wcs (const AcGeVector3d &normal, AcGePoint3d &point) {
	point.transformBy (AcGeMatrix3d::planeToWorld (normal)) ;
}

void ucs2wcs (const AcGeVector3d &normal, AcGeVector3d &vect) {
	vect.transformBy (AcGeMatrix3d::planeToWorld (normal)) ;
}

void wcs2ucs (const AcGeVector3d &normal, AcGePoint3d &point) {
	point.transformBy (AcGeMatrix3d::worldToPlane (normal)) ;
}

void wcs2ucs (const AcGeVector3d &normal, AcGeVector3d &vect) {
	vect.transformBy (AcGeMatrix3d::worldToPlane (normal)) ;
}

double xformDbl (const AcGeMatrix3d &xform, double dbl) {
	if ( !xform.isUniScaledOrtho () )
		return (dbl) ;
	AcGeScale3d sc ;
	sc.extractScale (xform) ;
	return (dbl * sc.sx) ;
}
