// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/PieHlrPex/PieHlrPex.cpp#3 $ $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////


#include "StdAfx.h"
#include "StdArx.h"
#include "resource.h"

#include "PiePex.h"

HINSTANCE _hdllInstance =NULL ;

// NOTE: DO NOT edit the following lines.
//{{AFX_ARX_MSG
void InitApplication();
void UnloadApplication();
//}}AFX_ARX_MSG

// NOTE: DO NOT edit the following lines.
//{{AFX_ARX_ADDIN_FUNCS
//}}AFX_ARX_ADDIN_FUNCS

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point
extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
        _hdllInstance = hInstance;
	} else if (dwReason == DLL_PROCESS_DETACH) {
	}
	return TRUE;    // ok
}



/////////////////////////////////////////////////////////////////////////////
// ObjectARX EntryPoint
extern "C" AcRx::AppRetCode 
acrxEntryPoint(AcRx::AppMsgCode msg, void* pkt)
{
	switch (msg) {
	case AcRx::kInitAppMsg:
		// Comment out the following line if your
		// application should be locked into memory
		acrxDynamicLinker->unlockApplication(pkt);
		acrxDynamicLinker->registerAppMDIAware(pkt);

		if ( !acrxServiceIsRegistered (AsdkPieServiceName) ) {
			//----- If it does not work then try loading it from the search path
			if ( !acrxDynamicLinker->loadModule (ACRX_T("AsdkPie.dbx"), false, true) ) {
				acutPrintf (ACRX_T("\nCannot continue!")) ;
				acutPrintf (ACRX_T("\nUnable to load 'AsdkPie.dbx', the module is probably not in the AutoCAD search path.\n")) ;
				//----- Return an Error, so AutoCAD will unload that module
				//return AcRx::kRetError ;
			}
		}
		//----- Bump the reference count 
		acrxLoadModule (ACRX_T("AsdkPie.dbx"), false, false) ;

		InitApplication();
		break;
	case AcRx::kUnloadAppMsg:
		UnloadApplication();
		acrxDynamicLinker->unloadModule (ACRX_T("AsdkPie")) ;
		break;
	}
	return AcRx::kRetOK;
}


// Init this application. Register your
// reactors, custom classes...
void InitApplication()
{
	// NOTE: DO NOT edit the following lines.
	//{{AFX_ARX_INIT
	//}}AFX_ARX_INIT

	// TODO: add your initialization functions
	Asdk2dSector::desc ()->addX (AsdkHiddenLineBase::desc (), new AsdkHiddenLinePie) ;

}

// Unload this application. Unregister all objects
// registered in InitApplication.
void UnloadApplication()
{
	// NOTE: DO NOT edit the following lines.
	//{{AFX_ARX_EXIT
	//}}AFX_ARX_EXIT

	// TODO: clean up your application
	delete Asdk2dSector::desc ()->delX (AsdkHiddenLineBase::desc ()) ;

}

