// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/PieHlrPex/PiePex.cpp#2 $ $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "StdArx.h"

#include "PiePex.h"

//-----------------------------------------------------------------------------
Acad::ErrorStatus AsdkHiddenLinePie::prepare (AcDbEntity *pEnt, AcDbVoidPtrArray &bodies, int control, const AcDbViewport *pVp) {

	//----- Check if it is really an Asdk2dSector
	Asdk2dSector *pSector =Asdk2dSector::cast (pEnt) ;
	if ( !pEnt )
		return (Acad::eInvalidInput) ;
	//----- We can do other useful checks if accurate for our object.



	//----- We want our Asdk2dSector to behave like a region
	//----- so the easiest thing to do is to create an AcDbregion
	//----- from our Asdk2dSector entity

	//----- Asdk2dSector is derived from AcDbEntity and not from AcDbCurve
	//----- So we need someextra work to create the region, instead of just
	//----- passing a pointer to the constructeur.

	AcDbArc *pArc =new AcDbArc (pSector->center (), pSector->normal (), pSector->radius (), pSector->start (), pSector->stop ()) ;
	AcGePoint3d pt0 ;
	pArc->getStartPoint (pt0) ;
	AcGePoint3d pt1 ;
	pArc->getEndPoint (pt1) ;


	AcDbLine *pLine0 =new AcDbLine (pSector->center (), pt0) ;
	pLine0->setNormal (pSector->normal ()) ;
	AcDbLine *pLine1 =new AcDbLine (pSector->center (), pt1) ;
	pLine0->setNormal (pSector->normal ()) ;

	AcDbVoidPtrArray pte ;
	pte.append (pLine0) ;
	pte.append (pLine1) ;
	pte.append (pArc) ;

	//----- Create the region
	AcDbVoidPtrArray ptr ;
	AcDbRegion::createFromCurves (pte, ptr) ;
	AcDbRegion *pRegion =(AcDbRegion *)ptr.at (0) ;
	pRegion->setColorIndex (pSector->colorIndex ()) ;
	pRegion->setLayer (pSector->layerId ()) ;

	//----- Clean memory
	delete pLine0 ;
	delete pLine1 ;
	delete pArc ;

	//----- Forward the call
	return (ACRX_X_CALL (pRegion, AsdkHiddenLineBase)->prepare (pRegion, bodies, control, pVp)) ;

	//----- Note: Here we do only one AcDbRegion, but if it is necessary we may create multiple
	//----- entity and forwards as many call we have create entity.

//	return (Acad::eOk) ;
}      
               
//Acad::ErrorStatus AsdkHiddenLinePie::getBody (void *pBodyData, int control) {
//	return (Acad::eInvalidInput) ;
//}
