// $Header: //depot/acad/develop/global/src/arxsdk/modules/AsdkHlrApi/Samples/HlrArxCustom/PieUi/PieUiCommands.cpp#3 $ $Change: 293540 $ $DateTime: 2012/01/03 10:55:53 $ $Author: patti $
// $NoKeywords: $
//
//////////////////////////////////////////////////////////////////////////////
//
//  Copyright 2012 Autodesk, Inc.  All rights reserved.
//
//  Use of this software is subject to the terms of the Autodesk license 
//  agreement provided at the time of installation or download, or which 
//  otherwise accompanies this software in either electronic or hard copy form.   
//
//////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////
// ObjectARX defined commands

#include "StdAfx.h"
#include "StdArx.h"

#include "geassign.h"
#define PI 3.141592

// This is command 'PIE'
void asdkpie()
{
	AcGePoint3d centerPoint ;
    if ( acedGetPoint (NULL, ACRX_T("Center: "), asDblArray (centerPoint)) != RTNORM )
		return ;

	double radius ;
	if ( acedGetDist (asDblArray (centerPoint), ACRX_T("Radius: "), &radius) != RTNORM || radius <= 0 )
		return ;

	AcGePoint3d startPoint ;
	double start, stop ;
	if ( acedGetPoint (asDblArray (centerPoint), ACRX_T("Start point: "), asDblArray (startPoint)) != RTNORM )
		return ;
	start =acutAngle (asDblArray (centerPoint), asDblArray (startPoint)) ;
	if ( acedGetAngle (asDblArray (centerPoint), ACRX_T("Angle: "), &stop) != RTNORM )
		return ;
	if ( stop >= 2*PI )
		stop -=2*PI ;

	Asdk2dSector *pPie =new Asdk2dSector ;
	pPie->setDatabaseDefaults () ;
	pPie->setCenter (centerPoint) ;
	pPie->setRadius (radius) ;
	pPie->setStart (start) ;
	pPie->setStop (stop) ;
	pPie->setVisibility (AcDb::kVisible) ;

	AcDbDatabase *pDb =acdbHostApplicationServices ()->workingDatabase () ;

	AcDbBlockTable *pTbl =NULL ;
	pDb->getBlockTable (pTbl, AcDb::kForRead) ;

	AcDbBlockTableRecord *pTblRec =NULL ;
	pTbl->getAt (ACDB_MODEL_SPACE, pTblRec, AcDb::kForWrite) ;

	AcDbObjectId idEnt ;
	pTblRec->appendAcDbEntity (idEnt, pPie) ;

	pPie->close () ;
	pTblRec->close () ;
	pTbl->close () ;
}

